//util.cpp
#include <d3d9.h>
#include <d3dx9.h>
#include "util.h"


void MatrixLerp(D3DXMATRIX* pOut, const D3DXMATRIX* m1, const D3DXMATRIX* m2, float t)
{
#if  0
	// ִϸ̼   
	*pOut = (1 - t) * (*m1) + t * (*m2);
#else
	//ִϸ̼   
	D3DXQUATERNION	q, q1, q2;
	D3DXVECTOR3	v, v1, v2;

	D3DXQuaternionRotationMatrix(&q1, m1);
	D3DXQuaternionRotationMatrix(&q2, m2);

	v1 = D3DXVECTOR3(m1->_41, m1->_42, m1->_43);
	v2 = D3DXVECTOR3(m2->_41, m2->_42, m2->_43);

	//ġ   
	v = (1 - t) * v1 + t * v2;

	// ȸ  
	D3DXQuaternionSlerp(&q, &q1, &q2, t);

	// ȸ ķ ȯ
	D3DXMatrixRotationQuaternion(pOut, &q);

	// ġ 
	pOut->_41 = v.x;
	pOut->_42 = v.y;
	pOut->_43 = v.z;
#endif
}
