//EHardwareBone
#ifndef EHARDWAREBONE_H
#define EHARDWAREBONE_H

#include <d3d9.h>
#include <d3dx9.h>
#include "EMesh.h"
#include "EHardwareBoneMesh.h"


class EHardwareBone : public EMesh
{
public:
	EHardwareBone( LPDIRECT3DDEVICE9 pDevice );
	virtual ~EHardwareBone();

	virtual	const char*	GetClassName();

protected:
	virtual int		OnRender();
	virtual void	OnFrameMove();

public:
	int		CreateVertexBuffer( XmlNode* pXmlNode );

public:
	std::vector<VertexInfo>		m_vertexArr;
	HardwareBlendVertex*		m_pMeshVerts; 
	HardwareBoneVertex*			m_pBoneVerts;

	HardwareFaceIncex*			m_pIndex;
};

#endif