//EShaderBone
#ifndef ESHADERBONE_H
#define ESHADERBONE_H

#include <d3d9.h>
#include <d3dx9.h>
#include "EMesh.h"
#include "EShaderBoneMesh.h"


class EShaderBone : public EMesh
{
public:
	EShaderBone( LPDIRECT3DDEVICE9 pDevice );
	virtual ~EShaderBone();

	virtual	const char*	GetClassName();

protected:
	virtual int		OnRender();
	virtual void	OnFrameMove();

public:
	int		CreateVertexBuffer( XmlNode* pXmlNode );

public:
	std::vector<VertexInfo>		m_vertexArr;
	ShaderBlendVertex*			m_pMeshVerts; 
	ShaderBoneVertex*			m_pBoneVerts;

	ShaderFaceIncex*			m_pIndex;
};

#endif